/*PHOTOFEED V2*/
pfeed_try();

function pfeed_try() {
    try {
        if (jQuery) {
            pfeed_init();
            //close if jQuery statement
                }
    } catch (e) {
        console.log("PFEED: jQuery not active... waitting");
        setTimeout(function() {
            pfeed_try();
        }, 1e3);
    }
}

function pfeed_init() {
    if (pfeed_debug == 1) {
        console.log("PFEED: jQuery loaded. Pfeed working...");
    }
    jQuery(document).ready(function() {
        jQuery(".pfeed_next").click(function(e) {
            nextemelement();
        });
        inserfirst();
        //CREATE WRAPPER
                var clase_modern = "basic";
        var clase_bs_version = "bs_version_3";
        if (jQuery(".main_pfeed.modern").length >= 1) {
            clase_modern = "modern";
        }
        if (jQuery(".main_pfeed.bs_version_4").length >= 1) {
            clase_bs_version = "bs_version_4";
        }
        jQuery("body").append('<div class="pfeed_modal_wrapper ' + clase_modern + " " + clase_bs_version + '"></div>');
        jQuery(".main_pfeed").on("click", ".pfeed_wrapper", function() {
            var window_h = window.innerHeight;
            var object_h = jQuery(this).children(".modal").children(".modal-dialog").height();
            if (pfeed_debug == 1) {
                console.log("w_h:" + window_h);
                console.log("o_h:" + object_h);
            }
        });
    });
}

function inserfirst() {
    var pfeed_user = jQuery(".pfeed_user").val();
    var pfeed_total_limit = jQuery(".pfeed_total_limit").val();
    //if(pfeed_total_limit == '0') pfeed_total_limit= '20';
    //index.php?option=com_ajax&module=social&method=getTwitter&format=json
        jQuery.ajax({
        url: window.location.pathname + "?option=com_ajax&module=pfeed&method=nextelement&first=true&pfeed_user=" + pfeed_user + "&pfeed_total_limit=" + pfeed_total_limit + "&format=json",
        //cache: false,
        beforeSend: function(xhr) {
            //loading
            time = new Date();
        }
    }).done(function(datos) {
        jQuery(".pfeed_next").html(datos);
        jQuery(".pfeed_next").html('<i class="fa fa-plus-circle"></i>');
        //limit total
                var limit_total = jQuery(".pfeed_total_limit").val();
        //if(limit_total !=0) jQuery('.pfeed_next').hide();
                if (limit_total == 0) limit_total = 20;
        if (datos.data.pagination.next_max_id != "") {
            jQuery(".pfeed_max_id").val(datos.data.pagination.next_max_id);
        }
        for (var i = 0; i < limit_total; i++) {
            //jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");
            insert_elements(datos.data.data[i], i);
        }
        if (pfeed_debug == 1) {
            console.log("Pfeed time to load: " + new Date() - time);
        }
    });
}

function nextemelement() {
    var max_id = jQuery(".pfeed_max_id").val();
    var pfeed_user = jQuery(".pfeed_user").val();
    var pfeed_total_limit = jQuery(".pfeed_total_limit").val();
    var pfeed_element_num = jQuery(".pfeed_element_num").val();
    //not elegant:S but..works
        if (pfeed_total_limit == 0) {
        pfeed_total_limit = 999999;
    }
    jQuery(".pfeed_next").html('<i class="fa fa-cog fa-spin"></i>');
    //CHECK LOADED
        if (check_bs_max()) {
        //no hace falta llamar a instagram
        class_bs_max();
        jQuery(".pfeed_next").html('<i class="fa fa-plus-circle"></i>');
        return;
    } else if (pfeed_total_limit > pfeed_element_num) {
        //LOAD MORE FROM INSTAGRAM
        //index.php?option=com_ajax&module=social&method=getTwitter&format=json
        jQuery.ajax({
            url: window.location.pathname + "?option=com_ajax&module=pfeed&method=nextelement&pfeed_user=" + pfeed_user + "&max_id=" + max_id + "&format=json",
            //cache: true,
            beforeSend: function(xhr) {
                //LOADING
                jQuery(".pfeed_next").html('<i class="fa fa-cog fa-spin"></i>');
            }
        }).done(function(datos) {
            console.log(datos);
            //console.log(jQuery.hasData(datos.data.pagination));
                        if (jQuery(".pfeed_max_id").val() == "fin") {
                class_bs_max();
                return;
            } else if (datos.data.pagination.next_max_id != undefined) {
                jQuery(".pfeed_max_id").val(datos.data.pagination.next_max_id);
            } else {
                //jQuery('.pfeed_next').hide();
                jQuery(".pfeed_max_id").val("fin");
            }
            //for (var i = 0; i < parseInt(datos.data.length); i++) {
                        for (var i = 0; i < datos.data.data.length; i++) {
                //jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");
                if (i < pfeed_total_limit) {
                    insert_elements(datos.data.data[i], i + 20);
                } else {
                    break;
                }
            }
            class_bs_max();
            //jQuery('.main_pfeed').append(data);
                });
    } else {
        class_bs_max();
    }
}

function check_bs_max() {
    //LG
    var bs_max_lg = jQuery(".pfeed_bs_max_lg").val();
    var bs_max_md = jQuery(".pfeed_bs_max_md").val();
    var bs_max_sm = jQuery(".pfeed_bs_max_sm").val();
    var bs_max_xs = jQuery(".pfeed_bs_max_xs").val();
    //hago un array para descubrir la setting mayor
        var array_settings = [ bs_max_lg, bs_max_md, bs_max_sm, bs_max_xs ];
    var max_settings = Math.max.apply(Math, array_settings);
    var el_loaded = jQuery(".pfeed_element_num").val();
    var el_hidden_lg = jQuery("div[class*=hidden-lg]").length;
    var el_hidden_md = jQuery("div[class*=hidden-md]").length;
    var el_hidden_sm = jQuery("div[class*=hidden-sm]").length;
    var el_hidden_xs = jQuery("div[class*=hidden-xs]").length;
    //hago un array para descubrir el menos números de ocultos
        var array_hidden = [ el_hidden_lg, el_hidden_md, el_hidden_sm, el_hidden_xs ];
    var min_hidden = 20 - Math.min.apply(Math, array_hidden);
    //var elements_displayed = el_loaded-elements_hidden;
        var suma = max_settings + min_hidden;
    var elem_loaded = jQuery(".pfeed_element_num").val();
    if (suma < elem_loaded) {
        //NO necesito actualizar
        //console.log("no update");
        return true;
    } else {
        //necesito actualizar
        //console.log("update");
        return false;
    }
    //var array_elements = [bs_max_lg,bs_max_md];
}

function class_bs_max() {
    //LG
    var bs_max_lg = jQuery(".pfeed_bs_max_lg").val();
    var element_h_lg = jQuery(".pfeed_wrapper.hidden-lg");
    for (var i = 0; i <= bs_max_lg - 1; i++) {
        element_h_lg.eq(i).removeClass("hidden-lg");
    }
    //MD
    var bs_max_md = jQuery(".pfeed_bs_max_md").val();
    var element_h_md = jQuery(".pfeed_wrapper.hidden-md");
    for (var i = 0; i <= bs_max_md - 1; i++) {
        element_h_md.eq(i).removeClass("hidden-md");
    }
    //SM
    var bs_max_sm = jQuery(".pfeed_bs_max_sm").val();
    var element_h_sm = jQuery(".pfeed_wrapper.hidden-sm");
    for (var i = 0; i <= bs_max_sm - 1; i++) {
        element_h_sm.eq(i).removeClass("hidden-sm");
    }
    //XS
    var bs_max_xs = jQuery(".pfeed_bs_max_xs").val();
    var element_h_xs = jQuery(".pfeed_wrapper.hidden-xs");
    for (var i = 0; i <= bs_max_xs - 1; i++) {
        element_h_xs.eq(i).removeClass("hidden-xs");
    }
    //boton
    check_plus_button();
    jQuery(".pfeed_next").html('<i class="fa fa-plus-circle"></i>');
    return true;
}

function check_plus_button() {
    var el_hidden_lg = jQuery("div[class*=hidden-lg]").length;
    var el_hidden_md = jQuery("div[class*=hidden-md]").length;
    var el_hidden_sm = jQuery("div[class*=hidden-sm]").length;
    var el_hidden_xs = jQuery("div[class*=hidden-xs]").length;
    var pfeed_max_id = jQuery(".pfeed_max_id").val();
    if (pfeed_max_id == "fin") pfeed_max_id = true;
    var boton = jQuery(".pfeed_next");
    //LG
        if (pfeed_max_id && el_hidden_lg == 0) {
        //console.log("deberia esconder el boton en lg");
        boton.addClass("hidden-lg");
        insert_credits();
    }
    //MD
        if (pfeed_max_id && el_hidden_md == 0) {
        //console.log("deberia esconder el boton en lg");
        boton.addClass("hidden-md");
        insert_credits();
    }
    //SM
        if (pfeed_max_id && el_hidden_sm == 0) {
        //console.log("deberia esconder el boton en lg");
        boton.addClass("hidden-sm");
        insert_credits();
    }
    //XS
        if (pfeed_max_id && el_hidden_xs == 0) {
        //console.log("deberia esconder el boton en lg");
        boton.addClass("hidden-xs");
        insert_credits();
    }
}

function insert_credits() {
    if (jQuery(".pfeed_license").val() == 0) {
        if (jQuery(".jomgram_el_credits").length == 0) {
            jQuery(".main_pfeed").append('<div class="jomgram_el_credits"><small>PhotoFeed by <a href="https://jtotal.org/joomla/modules/photofeed" rel="nofollow">jtotal.org</a></small>');
        }
    }
}

function insert_elements(img, key) {
    var bs_version_max_lg = "hidden-lg";
    var bs_version_max_md = "hidden-md";
    var bs_version_max_sm = "hidden-sm";
    var bs_version_max_xs = "hidden-xs";
    if (php_bs_version == "3") {
        //BOTSTRAP VERSION 3
        var img_class = "img-responsive";
    } else if (php_bs_version == "4") {
        //BOTSTRAP VERSION 4
        var img_class = "img-fluid";
    }
    //LG
        var bs_lg = jQuery(".pfeed_bs_lg").val();
    var bs_max_lg = jQuery(".pfeed_bs_max_lg").val();
    //BS_MAX_LG
        var class_bs_max_lg = "";
    if (key >= bs_max_lg) {
        class_bs_max_lg = bs_version_max_lg;
    }
    //MD
        var bs_md = jQuery(".pfeed_bs_md").val();
    var bs_max_md = jQuery(".pfeed_bs_max_md").val();
    var class_bs_max_md = "";
    if (key >= bs_max_md) {
        class_bs_max_md = bs_version_max_md;
    }
    //SM
        var bs_sm = jQuery(".pfeed_bs_sm").val();
    var bs_max_sm = jQuery(".pfeed_bs_max_sm").val();
    var class_bs_max_sm = "";
    if (key >= bs_max_sm) {
        class_bs_max_sm = bs_version_max_sm;
    }
    //XS
        var bs_xs = jQuery(".pfeed_bs_xs").val();
    var bs_max_xs = jQuery(".pfeed_bs_max_xs").val();
    var class_bs_max_xs = "";
    if (key >= bs_max_xs) {
        class_bs_max_xs = bs_version_max_xs;
    }
    //REFORMAT to NOP (todo)
    //bs_lg = 0 ? '' : 'col-lg-'+bs_lg;
        bs_lg = "col-lg-" + bs_lg;
    //var limit_total = jQuery('.pfeed_total_limit').val()*jQuery('.pfeed_pagenum').val();
        var limit_class = "";
    var html = '<div class="pfeed_wrapper ' + limit_class + " " + bs_lg + " col-md-" + bs_md + " col-sm-" + bs_sm + " col-xs-" + bs_xs + " " + class_bs_max_lg + " " + class_bs_max_md + " " + class_bs_max_sm + " " + class_bs_max_xs + '">';
    html += '<a class="thumbnail" data-toggle="modal" data-target="#pfeed_modal_' + key + '">';
    html += '<img class="' + img_class + '" src="' + img.images.low_resolution.url + '" />';
    html += '<input name="standard_res" class="standard_res" type="hidden" value="' + img.images.standard_resolution.url + '"/>';
    html += '<input name="pfeed_caption" class="pfeed_caption" type="hidden" value="' + img.images.caption + '"/>';
    html += '<input name="pfeed_likes" class="pfeed_likes" type="hidden" value="' + img.likes.count + '"/>';
    html += "</a>";
    //html += '</div>';
        if (img.caption !== null) {
        var caption = img.caption.text;
    } else {
        var caption = "";
    }
    var fecha = new Date(1e3 * parseInt(img.created_time));
    var modal = '<div class="modal fade" id="pfeed_modal_' + key + '" tabindex="-1" role="dialog">';
    modal += '<div class="modal-dialog" role="document">';
    modal += '<div class="modal-content">';
    //modal += '<!--<div class="modal-header"></div>-->';
        modal += '<div class="modal-body"><img class="' + img_class + '" src="' + img.images.standard_resolution.url + '"/></div>';
    modal += '<div class="modal-footer"> <div class="d-flex justify-content-between"><h4 class="modal-title" id="pfeed_modal_title">' + caption + "</h4>";
    modal += '<a class="d-flex pfeed_fecha_creacion"> <i class="fa fa-calendar-o"></i><span class="pfeed_fecha_creacion_span"> ' + fecha.toLocaleDateString() + '</span></a></div><div class="clearfix"></div>';
    //$modal .= $likes;
        modal += '<div class="row d-flex justify-content-between">';
    modal += '<div class="col-sm-6 pull-left likes_comments_count">';
    //LIKES
        if (checklicense() && jQuery(".pfeed_likes").val() == 1) {
        modal += insert_likes(img.likes, key);
    }
    //COMMENTS
        if (checklicense() && jQuery(".pfeed_comments").val() == 1) {
        modal += insert_comments_number(img.comments, key, img.user);
    }
    modal += "</div>";
    if (checklicense()) {
        modal += '<div class="btn-group pull-right pfeed_close_wrapper"><button type="button" class="btn btn-default btn-sm">';
        modal += '<a href="https://www.instagram.com/' + img.user.username + '" target="_blank"> ' + img.user.username + "</a></button>";
        //modal += '<button type="button" class="btn btn-default pfeed_close" data-dismiss="modal"><i class="fa fa-times-circle"></i></button>';
                modal += "</div>";
    }
    modal += "</div>";
    if (!checklicense()) {
        modal += '<hr class="clearfix">';
        modal += '<div class="pull-right d-flex justify-content-between"><small>powered by <a href="https://jtotal.org" target="_blank" rel="nofollow"> jtotal.org</a></small>';
        modal += '<div class="btn-group pull-right pfeed_close_wrapper"><button type="button" class="btn btn-default btn-sm">';
        modal += '<a href="https://www.instagram.com/' + img.user.username + '" target="_blank"> ' + img.user.username + "</a></button>";
        //modal += '<button type="button" class="btn btn-default pfeed_close" data-dismiss="modal"><i class="fa fa-times-circle"></i></button>';
                modal += "</div>";
        modal += "</div>";
    }
    modal += '<button type="button" class="btn btn-default pfeed_close" data-dismiss="modal"><i class="fa fa-times-circle"></i></button>';
    modal += "</div></div></div>";
    modal += "</div></div></div>";
    //html += modal;
        var element_num = parseInt(jQuery(".pfeed_element_num").val()) + 1;
    jQuery(".pfeed_element_num").val(element_num);
    jQuery(".main_pfeed").append(html);
    jQuery(".pfeed_modal_wrapper").append(modal);
}

function insert_comments(comments, key, usuario) {
    var comentarios = "";
    //console.log('comentarios:'+comments.count);
        if (comments.count >= 1) {
        //comentarios += '<div class="pfeed_comments_div table-responsive">';
        comentarios += '<table class="pfeed_comments_table table table-striped table-condensed">';
        for (var i = 0; i < comments.count; i++) {
            var fecha = new Date(1e3 * parseInt(comments.data[i].created_time));
            var tipo_globo = "";
            if (usuario.id == comments.data[i].from.id) {
                var tipo_globo = '<i class="fa fa-comment"></i>';
            } else {
                var tipo_globo = '<i class="fa fa-comments"></i>';
            }
            //jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");
            //insert_elements(datos.data.data[i], i++);
                        comentarios += '<tr><td class="pfeed_comments_user_td"><a class="pfeed_comments_user"><span>' + comments.data[i].from.username + '</span><img width="24px" src="' + comments.data[i].from.profile_picture + '"/></td>';
            comentarios += "<td>" + tipo_globo + " " + comments.data[i].text + '<td><td class="pfeed_comments_fecha"><small>' + fecha.toLocaleDateString() + "</small></td></tr>";
        }
        comentarios += "</table>";
        //comentarios += '</div>';
        }
    return comentarios;
}

function insert_comments_number(comments, key, usuario) {
    var comentarios = "";
    if (comments.count >= 1) {
        //comentarios += '<div class="pfeed_comments_div table-responsive">';
        comentarios += '<div class="pfeed_comments"><i class="fa fa-comment fa-2x"></i> <span class="pfeed_comments_count"> ' + comments.count + "</span></div>";
    } else {
        comentarios += '<div class="pfeed_comments"><i class="fa fa-comment fa-2x"></i> <span class="pfeed_comments_count"> 0 </span></div>';
    }
    return comentarios;
}

function insert_likes(likes, key) {
    var megustas = "";
    if (likes.count >= 1) {
        megustas += '<div class="pfeed_likes"><i class="fa fa-heart fa-2x"></i> <span class="pfeed_likes_count"> ' + likes.count + "</span></div>";
        /*
				for (var i = 0; i < likes.count; i++) {
					var fecha = new Date(1000*parseInt(likes.data[i].created_time));
				    //jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");
				   //insert_elements(datos.data.data[i], i++);
				    megustas += '<tr><td class="pfeed_comments_user_td"><a class="pfeed_comments_user"><span>'+likes.data[i].from.username+'</span><img width="24px" src="'+likes.data[i].from.profile_picture+'"/></td>';
				    megustas += '<td><i class="fa fa-comments-o"></i> '+likes.data[i].text+'<td><td class="pfeed_comments_fecha"><small>'+fecha.toLocaleDateString()+'</small></td></tr>';
				}
				megustas += '</table>';
		*/    } else {
        megustas += '<i class="fa fa-heart"></i>';
    }
    return megustas;
}

function checklicense() {
    if (jQuery(".pfeed_license").val() == 0) {
        return false;
    } else {
        return true;
    }
}