/*PHOTOFEED*/
//2.0
var fotorama;
var blue;
var pfeed_img_path = php_feed_base+'media/mod_pfeed/images/';

var contadorImages = 0;

var pfeed_paging = false;
var pfeed_license = false;


var bs_max_lg = 0;
var bs_max_md =	0;
var bs_max_sm =	0;
var bs_max_xs = 0;

var pfeed_element_num = 0;

pfeed_layout = '0';

pfeed_try()

function pfeed_try() {
	try {
		if (jQuery) {
			pfeed_init();
			//close if jQuery statement
		}
	} catch (e) {
		pf_debug("PFEED: jQuery not active... waitting a bit");
		setTimeout(function () {
			pfeed_try()
		}, 1000);
	}
}



function pfeed_init() {

	pf_debug("PFEED: jQuery loaded. Pfeed working...");

	jQuery(document).ready(function () {


		jQuery('div.pfeed_options').parent().each(function(k,e){

			var moduleid = jQuery(e).children('.pfeed_options').attr('moduleid');
		
			//GET PARAMS
			jQuery.ajax({
				url: window.location.pathname + "?option=com_ajax&module=pfeed&method=pfeedParams&moduleid=" + moduleid + "&format=json",
				//cache: false,
				beforeSend: function (xhr) {
					//loading
				}
			})
			.done(function (datos) {

				var profile_url =  'https://www.instagram.com/'+datos.data.user;
				var profile_name =  datos.data.user;




				inserfirst(datos.data);
				

				//CREATE WRAPPER
				var clase_modern = 'basic';
				var clase_bs_version = 'bs_version_3';
	
				var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
	
				if (currentFeed.find('.main_pfeed.modern').length >= 1) {
					clase_modern = 'modern';
				}

				if (currentFeed.find('.main_pfeed.bs_version_4').length >= 1) {
					clase_bs_version = 'bs_version_4';
				}

				


				//HIDE
				jQuery('.pfeed_modal').mousedown(function(event){
					if(event.target.id){
						if(event.target.id == 'pfeed_modal_'+moduleid){
							jQuery(this).addClass('pfeed_hide').removeClass('pfeed_show');
						}
					}
				});

	
	
				currentFeed.find('.pfeed_next').click(function (e) {
					nextemelement(moduleid,datos.data);
				});
	



				/************************************** */
				/************************************** */
				/*************  blueimp modal ************** */
				/************************************** */
				/************************************** */



				if(datos.data.pfeed_load_blueimp=="0"){
					return;
				}
				


				var blueimp_wrapper = '<div id="blueimp-gallery'+moduleid+'" class="blueimp-gallery" style="position: absolute;">';

				//blueimp_wrapper += modal_pfeed;

				blueimp_wrapper += '<div class="slides"></div>';
				//blueimp_wrapper += '<h3 class="title"></h3>';
				//blueimp_wrapper += '<p class="description"></p>';
				//blueimp_wrapper += '<p class="likes"></p>';
				//blueimp_wrapper += '<a class="link"></a>';
				//blueimp_wrapper += '<p class="comments"></p>';


				//blueimp_wrapper += '<a class="prev">‹</a>';
				//blueimp_wrapper += '<a class="next">›</a>';
				//blueimp_wrapper += '<a class="close">×</a>';
				//blueimp_wrapper += '<a class="play-pause"></a>';
				//blueimp_wrapper += '<ol class="indicator"></ol>';
				blueimp_wrapper += '</div>';



				modal_pfeed = '<div class="pfeed_modal pfeed_hide" id="pfeed_modal_'+moduleid+'" tabindex="-1" role="dialog">';

				modal_pfeed += '  <div class="pfeed_modal-dialog" role="document">';
				modal_pfeed += '    <div class="pfeed_modal-content">';

				modal_pfeed += '  <a class="pfeed_modal_close" onclick="pfeed_hide_modal();"><img src="'+pfeed_img_path+'pfeed_close.svg"/></a>';

				//modal_pfeed += '      <div class="modal-header">';
				//modal_pfeed += '        <h3 class="title"></h3>';
				//modal_pfeed += '        <button type="button" class="close" data-dismiss="modal" aria-label="Close">';
				//modal_pfeed += '          <span aria-hidden="true">&times;</span>';
				//modal_pfeed += '        </button>';
				//modal_pfeed += '      </div>';
				modal_pfeed += '      <div class="pfeed_modal-body">';
				modal_pfeed += blueimp_wrapper;
				modal_pfeed += '      </div>';
				modal_pfeed += '      <div class="pfeed_modal-footer">';

					modal_pfeed += '      	<div class="pfeed_line1">';
						modal_pfeed += '      	<div class="pfeed_likes_comments">';
						//	modal_pfeed += '      	<p class="pfeed_likes_wrapper"><i class="fas fa-heart"></i> <a class="pfeed_likes"></a></p>';
						//	modal_pfeed += '      	<p class="pfeed_comments_wrapper"><i class="fas fa-comments"></i> <a class="pfeed_comments"></a></p>';
						modal_pfeed += '      </div>';

						modal_pfeed += '      	<p class="pfeed_profile_wrapper"><a class="pfeed_profile"></a></p>';
					modal_pfeed += '  </div>';

					modal_pfeed += '      	<div class="pfeed_line2">';
						modal_pfeed += '      	<p class="pfeed_title"></p>';
					modal_pfeed += '      </div>';

				modal_pfeed += '      </div>';
				modal_pfeed += '    </div>';
				modal_pfeed += '  </div>';
				modal_pfeed += '  </div>';



				jQuery('body').append(modal_pfeed);

	

				/************************************** */
				/************************************** */
				/*************  hide/show modal  ************** */
				/************************************** */
				/************************************** */




				document.getElementById('main_pfeed_id'+moduleid).onclick = function(event) {

					

					event = event || window.event
					var target = event.target || event.srcElement,
						link = target.src ? target.parentNode : target,
						
					  	options = {
							container: '#blueimp-gallery'+moduleid,
							pfmodal: '#pfeed_modal_'+moduleid+' .pfeed_modal-content',
							index: link, 
							event: event,
							carousel: false,
							unloadElements: true,
							reloadRange: 2,
							//toggleControlsOnSlideClick: false,
							titleElement: 'h3',
							continuous: false,
							controlsClass: 'blueimp-gallery-controls',
							onopen: function(event, index, slide) {
								//coloca la imagen
								//this.container.addClass('blueimp-gallery-controls');
								//show modal
								jQuery('.pfeed_modal').addClass('pfeed_show').removeClass('pfeed_hide');

								//PROFILE
								document.querySelector(this.options.pfmodal+' .pfeed_profile').innerHTML = "";
								
								
								
								if(document.querySelector('#pfeed_profile'+moduleid+' .pfeed_profile_wrapper') != null){
									var pfeed_profile = document.querySelector('#pfeed_profile'+moduleid+' .pfeed_profile_wrapper').innerHTML;
									document.querySelector(this.options.pfmodal+' .pfeed_profile').innerHTML = pfeed_profile;
								}
								
								


							},
							onslideend: function(event, index, slide) {
								//console.log("lala");
							},
							onslide: function(index, slide) {
								
								//LIKES
								/*var likes = this.list[index].getAttribute('data-likes');
									document.querySelector(this.options.pfmodal+' .pfeed_likes').innerHTML = ""
								if (likes) {
									document.querySelector(this.options.pfmodal+' .pfeed_likes').appendChild(document.createTextNode(likes));
								} 

	
								//comments
								var comments = this.list[index].getAttribute('data-comments');
								document.querySelector(this.options.pfmodal+' .pfeed_comments').innerHTML = ""
								if (comments) {
									document.querySelector(this.options.pfmodal+' .pfeed_comments').appendChild(document.createTextNode(comments));
								} */

								//pfeed_title
								var desc = this.list[index].getAttribute('data-description');
								document.querySelector(this.options.pfmodal+' .pfeed_title').innerHTML = "";

								//console.log(desc);
								if (desc != 'undefined') {
									document.querySelector(this.options.pfmodal+' .pfeed_title').appendChild(document.createTextNode(desc));
								} 

							},
							onclose: function(event, index, slide) {
								jQuery('.pfeed_modal').addClass('pfeed_hide').removeClass('pfeed_show');
								//console.log("klasjkaafjkl");
							}	
						},
					  	links = this.getElementsByTagName('a')
						blueimp.Gallery(links, options)
				}

			});

					
		});

		
	});

}



function pfeed_hide_modal(){
	jQuery('.pfeed_modal').addClass('pfeed_hide').removeClass('pfeed_show');
}





function inserfirst(params) {

	//console.log('------------***-----INSERFIRST-------**-------- ');
	var pfeed_user = params.user;
	var pfeed_total_limit =  params.pfeed_total_limit;

	var moduleid = params.moduleid;

	var first_url = window.location.pathname + "?option=com_ajax&module=pfeed&method=nextelement&moduleid="+moduleid+"&first=true&pfeed_user=" + pfeed_user + "&pfeed_total_limit=" + pfeed_total_limit + "&format=json";

 
	jQuery.ajax({
			url: first_url,
			//cache: false,
			beforeSend: function (xhr) {
				//loading
				time = new Date();
			}
		})
		.done(function (fdata) {

			if (pfeed_debug == 1) {
				console.log(fdata);
				//console.log(first_url);
			}

			//SI HAY ERRORES
			if (fdata.data == null) {
				//show profile
				jQuery('.pfeed_profile_a').removeClass('hide');
				var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
				currentFeed.find('.div_feed_next').html('<span>No data</span>');
				return;
			}

			//SI HAY ERRORES
			if (typeof fdata.data.error !== 'undefined') {
				//show profile
				jQuery('.pfeed_profile_a').removeClass('hide');
				var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
				currentFeed.find('.div_feed_next').html('<table class="table table-condensed table-striped"<tr><td>Pfeed ERROR</td><td></td></tr><tr><td>Message</td><td>'+fdata.data.error.message+'</td></tr><tr><td>Type</td><td>'+fdata.data.error.type+'</td></tr></table>');
				return;
			}




			//show profile
			jQuery('.pfeed_profile_a').removeClass('hide');


			var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
			var currentOptions = jQuery('.pfeed_unique'+moduleid);

			//currentFeed.find('.pfeed_next').html(fdata);
			currentFeed.find('.pfeed_next').html('<img class="pfeed_plus" alt="plus" src="'+pfeed_img_path+'plus-square-solid.svg"/>');

			//limit total
			var limit_total = params.pfeed_total_limit;	

			if (limit_total == 0) limit_total = 20;


			//jQuery('#pfeed_after'+moduleid).val(fdata.data.paging.cursors.after);

			
			//* UPDATE PAGING 
			if(fdata.data.paging.cursors.after == null){
				pfeed_paging = false;
			}else{
				pfeed_paging = fdata.data.paging.cursors.after;
			}

			
			//* BS MAX
			bs_max_lg = params.bs_max_lg;
			bs_max_md = params.bs_max_md;
			bs_max_sm = params.bs_max_sm;
			bs_max_xs = params.bs_max_xs;

/* 			console.log('bs_max_lg: '+bs_max_lg);
			console.log('bs_max_md: '+bs_max_md);
			console.log('bs_max_sm: '+bs_max_sm);
			console.log('bs_max_xs: '+bs_max_xs); */

			pfeed_layout = params.pfeed_layout;

			pfeed_license = params.jtlicense;
	
			//* INSERT ELEMENTS
			for (var i = 0; i < limit_total; i++) {
				//jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");
				insert_elements(fdata.data.data[i],i,params,currentOptions,moduleid);
			}


			pf_debug("Pfeed Time to load:" + (new Date() - time));
			


	});

}


function nextemelement(moduleid,params) {

	pf_debug('****************nextemelement****************');

	var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
	var currentOptions = jQuery('.pfeed_unique'+moduleid);
	

	var max_id = currentOptions.children('.pfeed_max_id').val();
	var after = pfeed_paging;
	var pfeed_user = params.user;

	var pfeed_total_limit = params.pfeed_total_limit;

	//var pfeed_element_num = currentOptions.children('.pfeed_element_num').val();
	
	//not elegant:S but..works
	if (pfeed_total_limit == 0) {
		pfeed_total_limit = 999999;
	}



	currentFeed.find('.pfeed_next').html('<img class="pfeed_loading" alt="loading" src="'+pfeed_img_path+'cog-solid.svg"/>');

	//CHECK LOADED

	if (check_bs_max(moduleid,params) || pfeed_paging==false) {
		//no hace falta llamar a instagram
		pf_debug('no hace falta llamar a instagram');
		class_bs_max(moduleid,params);
		jQuery('#pfeed_next'+moduleid).html('<img class="pfeed_plus" alt="plus" src="'+pfeed_img_path+'plus-square-solid.svg"/>');
		return;
	} else if (pfeed_total_limit > pfeed_element_num) {

		pf_debug('--*-*LOAD MORE FROM INSTAGRAM---*-*');

		//LOAD MORE FROM INSTAGRAM
		jQuery.ajax({
				url: window.location.pathname + "?option=com_ajax&module=pfeed&method=nextelement&moduleid="+moduleid+"&pfeed_user=" + pfeed_user + "&after=" + after + "&max_id=" + max_id + "&format=json",
				//cache: true,
				beforeSend: function (xhr) {
					//LOADING
					currentFeed.find('.pfeed_next').html('<img class="pfeed_loading" alt="loading" src="'+pfeed_img_path+'cog-solid.svg"/>');
				}
			})
			.done(function (datos) {

				pf_debug("DATOS nextelement");
				//console.log(datos);
				pf_debug(datos.data.data.length);
		
				
				//* UPDATE PAGING 
				
				if (pfeed_paging==false) {
					pfeed_paging = false;
					class_bs_max(moduleid,params);
					return;
				} else if (datos.data.data.length != 0) {
					pfeed_paging = datos.data.paging.cursors.after;
				} else {
					//jQuery('.pfeed_next').hide();
					pfeed_paging = false;
				}

				//* LAST elements
				if(datos.data.data.length <= 19){
					pfeed_paging = false;
				}
		

				//for (var i = 0; i < parseInt(datos.data.length); i++) {
				for (var i = 0; i < datos.data.data.length; i++) {
					//jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");

					if (i < pfeed_total_limit) {
						insert_elements(datos.data.data[i], i + 20,params,currentOptions,moduleid);
					} else {
						break;
					}
				}

				class_bs_max(moduleid,params);

				//jQuery('.main_pfeed').append(data);
			});
	} else {
		class_bs_max(moduleid,params);
	}
}


function check_bs_max(moduleid,params) {

	var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
	var currentOptions = jQuery('.pfeed_unique'+moduleid);


	//* AUTOMATIC MODE
 	if(params.bs_max_lg == 0) bs_max_lg = 12/params.bs_lg;
	if(params.bs_max_md == 0) bs_max_md = 12/params.bs_md;
	if(params.bs_max_sm == 0) bs_max_sm = 12/params.bs_sm;
	if(params.bs_max_xs == 0) bs_max_xs = 12/params.bs_xs;



	//hago un array para descubrir la setting mayor
	var array_settings = [bs_max_lg, bs_max_md, bs_max_sm, bs_max_xs];
	var max_settings = Math.max.apply(Math, array_settings);


	var el_hidden_lg = currentFeed.find('div[class*=hidden-lg]').length;
	var el_hidden_md = currentFeed.find('div[class*=hidden-md]').length;
	var el_hidden_sm = currentFeed.find('div[class*=hidden-sm]').length;
	var el_hidden_xs = currentFeed.find('div[class*=hidden-xs]').length;

	if(params.pfeed_layout == 'bs5'){
		el_hidden_lg = currentFeed.find('div[class*=d-lg-none]').length;
		el_hidden_md = currentFeed.find('div[class*=d-md-none]').length;
		el_hidden_sm = currentFeed.find('div[class*=d-sm-none]').length;
		el_hidden_xs = currentFeed.find('div[class*=d-xs-none]').length;
	}







/* 
	console.log('el_hidden_lg: '+el_hidden_lg);
	console.log('el_hidden_md: '+el_hidden_md);
	console.log('el_hidden_sm: '+el_hidden_sm);
	console.log('el_hidden_xs: '+el_hidden_xs);
	console.log('array_settings: '+array_settings);
 */
	//hago un array para descubrir el menor número de ocultos
	var array_hidden = [el_hidden_lg, el_hidden_md, el_hidden_sm, el_hidden_xs];
	var min_hidden = 20 - Math.min.apply(Math, array_hidden);

	//var elements_displayed = el_loaded-elements_hidden;
	var suma = max_settings + min_hidden;

	//var elem_loaded = currentOptions.children('.pfeed_element_num').val();
	var elem_loaded = pfeed_element_num;



	if (suma < elem_loaded) {
		//NO necesito actualizar
		pf_debug("no update");
		return true;
	} else {
		//necesito actualizar
		pf_debug("update");
		return false;
	}
	//var array_elements = [bs_max_lg,bs_max_md];
}

function class_bs_max(moduleid,params) {

	var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
	var currentOptions = jQuery('.pfeed_unique'+moduleid);


/* 	console.log('bs_max_lg: '+bs_max_lg);
	console.log('bs_max_md: '+bs_max_md);
	console.log('bs_max_sm: '+bs_max_sm);
	console.log('bs_max_xs: '+bs_max_xs); */

	var element_h_lg = currentFeed.find('.pfeed_wrapper.hidden-lg');
	var element_h_md = currentFeed.find('.pfeed_wrapper.hidden-md');
	var element_h_sm = currentFeed.find('.pfeed_wrapper.hidden-sm');
	var element_h_xs = currentFeed.find('.pfeed_wrapper.hidden-xs');

	var class_hidden_lg = 'hidden-lg';
	var class_hidden_md = 'hidden-md';
	var class_hidden_sm = 'hidden-sm';
	var class_hidden_xs = 'hidden-xs';

	if(pfeed_layout == 'bs5'){
		element_h_lg = currentFeed.find('.pfeed_wrapper.d-lg-none');
		element_h_md = currentFeed.find('.pfeed_wrapper.d-md-none');
		element_h_sm = currentFeed.find('.pfeed_wrapper.d-sm-none');
		element_h_xs = currentFeed.find('.pfeed_wrapper.d-xs-none');

		class_hidden_lg = 'd-lg-none';
		class_hidden_md = 'd-md-none';
		class_hidden_sm = 'd-sm-none';
		class_hidden_xs = 'd-xs-none';
	}


	//LG
	for (var i = 0; i <= bs_max_lg - 1; i++) {
		element_h_lg.eq(i).removeClass(class_hidden_lg);
	};

	//MD
	for (var i = 0; i <= bs_max_md - 1; i++) {
		element_h_md.eq(i).removeClass(class_hidden_md);
	};

	//SM
	for (var i = 0; i <= bs_max_sm - 1; i++) {
		element_h_sm.eq(i).removeClass(class_hidden_sm);
	};

	//XS
	for (var i = 0; i <= bs_max_xs - 1; i++) {
		element_h_xs.eq(i).removeClass(class_hidden_xs);
	};

	//boton
	check_plus_button(moduleid);


	currentFeed.find('.pfeed_next').html('<img alt="more" class="pfeed_plus" src="'+pfeed_img_path+'plus-square-solid.svg"/>');

	pf_debug('check_plus_butto++++: '+pfeed_element_num);

	return true;
}

function check_plus_button(moduleid) {

	pf_debug('*++************check_plus_button*************++*');

	var currentFeed = jQuery('.pfeed_unique'+moduleid).parent();
	var currentOptions = jQuery('.pfeed_unique'+moduleid);



	var el_hidden_lg = currentFeed.find('div[class*=hidden-lg]').length;
	var el_hidden_md = currentFeed.find('div[class*=hidden-md]').length;
	var el_hidden_sm = currentFeed.find('div[class*=hidden-sm]').length;
	var el_hidden_xs = currentFeed.find('div[class*=hidden-xs]').length;

	var class_hidden_lg = 'hidden-lg';
	var class_hidden_md = 'hidden-md';
	var class_hidden_sm = 'hidden-sm';
	var class_hidden_xs = 'hidden-xs';

	if(pfeed_layout == 'bs5'){
		el_hidden_lg = currentFeed.find('div[class*=d-lg-none]').length;
		el_hidden_md = currentFeed.find('div[class*=d-md-none]').length;
		el_hidden_sm = currentFeed.find('div[class*=d-sm-none]').length;
		el_hidden_xs = currentFeed.find('div[class*=d-xs-none]').length;

		class_hidden_lg = 'd-lg-none';
		class_hidden_md = 'd-md-none';
		class_hidden_sm = 'd-sm-none';
		class_hidden_xs = 'd-xs-none';
	}
	/*
	var pfeed_max_id = currentOptions.children('.pfeed_max_id').val();
	if (pfeed_max_id == 'fin') pfeed_max_id = true;
*/
	var pfeed_max_id = pfeed_paging;

	var boton = currentFeed.find('.pfeed_next');


	//LG
	if (!pfeed_max_id && el_hidden_lg == 0) {
		//console.log("deberia esconder el boton en lg");
		boton.addClass(class_hidden_lg);
		insert_credits();
	}
	//MD
	if (!pfeed_max_id && el_hidden_md == 0) {
		console.log("deberia esconder el boton en md");
		boton.addClass(class_hidden_md);
		insert_credits();
	}
	//SM
	if (!pfeed_max_id && el_hidden_sm == 0) {
		//console.log("deberia esconder el boton en sm");
		boton.addClass(class_hidden_sm);
		insert_credits();
	}
	//XS
	if (!pfeed_max_id && el_hidden_xs == 0) {
		//console.log("deberia esconder el boton en xs");
		boton.addClass(class_hidden_xs);
		insert_credits();
	}

}

function insert_credits() {

	if (!pfeed_license) {
		if (jQuery('.jomgram_el_credits').length == 0) {
			jQuery('.main_pfeed').append('<div class="jomgram_el_credits"><small>PhotoFeed by <a href="https://jtotal.org/joomla/modules/photofeed" rel="nofollow">jtotal.org</a></small>');
		}
	}
}



function insert_elements(img, key,params,options,moduleid='') {



	//escondo el boton
	/* 	if(params.pfeed_total_limit == contadorImages){
			jQuery('.pfeed_unique'+moduleid).parent().find('.pfeed_next').addClass('hidden-lg hidden-md hidden-sm hidden-xs');
		}
	*/

	if(img == undefined) return;

	contadorImages++;

	var bs_version_max_lg = 'hidden-lg';
	var bs_version_max_md = 'hidden-md';
	var bs_version_max_sm = 'hidden-sm';
	var bs_version_max_xs = 'hidden-xs';

	if(params.pfeed_layout == 'bs5'){
		bs_version_max_lg = 'd-lg-none';
		bs_version_max_md = 'd-md-none';
		bs_version_max_sm = 'd-sm-none';
		bs_version_max_xs = 'd-xs-none';
	}


	var img_class = "img-fluid";
	if (php_bs_version == '3') {
		var img_class = "img-responsive";
	}


	//LG
	var bs_lg = params.bs_lg;
	var bs_max_lg = params.bs_max_lg;

	//auto
	if(bs_max_lg=="0") bs_max_lg = 12/bs_lg;

	//BS_MAX_LG
	var class_bs_max_lg = '';
	if (key >= bs_max_lg) {
		class_bs_max_lg = bs_version_max_lg;
	}

	//MD
	var bs_md = params.bs_md;
	var bs_max_md = params.bs_max_md;
	//auto
	if(bs_max_md=="0") bs_max_md = 12/bs_md;

	var class_bs_max_md = '';
	if (key >= bs_max_md) {
		class_bs_max_md = bs_version_max_md;
	}

	//SM
	var bs_sm = params.bs_sm;
	var bs_max_sm = params.bs_max_sm;
	//auto
	if(bs_max_sm=="0") bs_max_sm = 12/bs_sm;

	var class_bs_max_sm = '';
	if (key >= bs_max_sm) {
		class_bs_max_sm = bs_version_max_sm;
	}

	//XS
	var bs_xs = params.bs_xs;
	var bs_max_xs = params.bs_max_xs;
	//auto
	if(bs_max_xs=="0") bs_max_xs = 12/bs_xs;

	var class_bs_max_xs = '';
	if (key >= bs_max_xs) {
		class_bs_max_xs = bs_version_max_xs;
	}


	//console.log(options);
	//REFORMAT to NOP (todo)
	//bs_lg = 0 ? '' : 'col-lg-'+bs_lg;
	bs_lg = 'col-lg-' + bs_lg;

	//console.log(params.pfeed_load_blueimp);


	//DOESNT WORK IN v2 ¯\_(ツ)_/¯
	/*
	var pfeed_thumbnail_size =  params.pfeed_thumbnail_size;
	if(pfeed_thumbnail_size == 'thumbnail' && img.thumbnail_url != null){
		var img_thumb = img.thumbnail_url;
	}else{
		var img_thumb = img.media_url;
	}
	*/
	
	//new in v2
	if(img.thumbnail_url != null){
		var img_thumb = img.thumbnail_url;
	}else{
		var img_thumb = img.media_url;
	}



	//var limit_total = jQuery('.pfeed_total_limit').val()*jQuery('.pfeed_pagenum').val();
	var limit_class = '';

	var html = '<div class="pfeed_wrapper pfeed_wrapper' +moduleid+' '+ limit_class + ' ' + bs_lg + ' col-md-' + bs_md + ' col-sm-' + bs_sm + ' col-' + bs_xs + ' ' + class_bs_max_lg + ' ' + class_bs_max_md + ' ' + class_bs_max_sm + ' ' + class_bs_max_xs + '">';
	

	//col
	if(params.pfeed_layout == 'bs5'){
		var html = '<div class="card pfeed_wrapper pfeed_wrapper' +moduleid+' '+ limit_class + ' ' + bs_lg + ' col-md-' + bs_md + ' col-sm-' + bs_sm + ' col-' + bs_xs + ' ' + class_bs_max_lg + ' ' + class_bs_max_md + ' ' + class_bs_max_sm + ' ' + class_bs_max_xs + '">';
	}

	



	//bs modal
/* 	html += '<a class="thumbnail" data-toggle="modal" data-target="#pfeed_modal_' + key + '">';
	html += '<img class="' + img_class + '" src="' + img_thumb + '" pfeed_hires="'+img.images.standard_resolution.url+'"/>';
	html += '<input name="standard_res" class="standard_res" type="hidden" value="' + img.images.standard_resolution.url + '"/>';
	html += '<input name="pfeed_caption" class="pfeed_caption" type="hidden" value="' + img.images.caption + '"/>';
	html += '<input name="pfeed_likes" class="pfeed_likes" type="hidden" value="' + img.likes.count + '"/>';
	html += '</a>'; */

	var caption = '';
	if (img.caption !== null) {
		var caption = img.caption;
	} else {
		var caption = '';
	}


	var lazyclass = '';
	var lazydata = '';
	if(params.pfeed_lazy == 1){
		lazyclass = 'lazyload';
		lazydata = 'data-';
	}

	var target = '';
	var a_modal = '';
	if(params.pfeed_load_blueimp=='0'){
		target='target="_blank"';
	}

	if(img.thumbnail_url != null){
		html += '<a type="video/mp4" '+a_modal+' href="'+img.media_url+'" '+target+' data-description="'+img.caption+'">';
			//html += '<i class="fab fa-youtube" style="position:absolute; "></i>';
			html += '<img  class="'+lazyclass+' ' + img_class + '" '+lazydata+'src="' + img_thumb + '" alt="'+caption+'" description="'+caption+'" pfeed_hires="'+img.media_url+'"/>';
		html += '</a>';

	}else{

		html += '<a '+a_modal+' href="'+img.media_url+'" '+target+' data-description="'+img.caption+'">';
			html += '<img class="'+lazyclass+' ' + img_class + '" '+lazydata+'src="' + img_thumb + '" alt="'+caption+'" description="'+caption+'" pfeed_hires="'+img.media_url+'"/>';
		html += '</a>';
	}


	//html += '</div>';

	var fecha = new Date(1000 * parseInt(img.created_time));

 

	//this is weird
	var element_num = parseInt(pfeed_element_num) + 1;
	pfeed_element_num = element_num;


	jQuery('#main_pfeed_id'+params.moduleid).append(html);


}



















function insert_comments(comments, key, usuario) {

	var comentarios = '';

	//console.log('comentarios:'+comments.count);

	if (comments.count >= 1) {

		//comentarios += '<div class="pfeed_comments_div table-responsive">';
		comentarios += '<table class="pfeed_comments_table table table-striped table-condensed">';

		for (var i = 0; i < comments.count; i++) {

			var fecha = new Date(1000 * parseInt(comments.data[i].created_time));
			var tipo_globo = '';

			if (usuario.id == comments.data[i].from.id) {
				var tipo_globo = '<i class="fa fa-comment"></i>';
			} else {
				var tipo_globo = '<i class="fa fa-comments"></i>';
			}
			//jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");
			//insert_elements(datos.data.data[i], i++);
			comentarios += '<tr><td class="pfeed_comments_user_td"><a class="pfeed_comments_user"><span>' + comments.data[i].from.username + '</span><img width="24px" src="' + comments.data[i].from.profile_picture + '"/></td>';
			comentarios += '<td>' + tipo_globo + ' ' + comments.data[i].text + '<td><td class="pfeed_comments_fecha"><small>' + fecha.toLocaleDateString() + '</small></td></tr>';

		}
		comentarios += '</table>';
		//comentarios += '</div>';

	}

	return comentarios;
}

function insert_comments_number(comments, key, usuario) {

	var comentarios = '';

	if (comments.count >= 1) {

		//comentarios += '<div class="pfeed_comments_div table-responsive">';
		comentarios += '<div class="pfeed_comments"><i class="fa fa-comment fa-2x"></i> <span class="pfeed_comments_count"> ' + comments.count + '</span></div>';
	} else {
		comentarios += '<div class="pfeed_comments"><i class="fa fa-comment fa-2x"></i> <span class="pfeed_comments_count"> 0 </span></div>';
	}

	return comentarios;
}

function insert_likes(likes, key) {

	var megustas = '';

	if (likes.count >= 1) {

		megustas += '<div class="pfeed_likes"><i class="fa fa-heart fa-2x"></i> <span class="pfeed_likes_count"> ' + likes.count + '</span></div>';

		/*
				for (var i = 0; i < likes.count; i++) {
					var fecha = new Date(1000*parseInt(likes.data[i].created_time));
				    //jQuery('.main_pfeed').append("<a class='big-square span2' target='_blank' href='" + datos.data.data[i] +"'><img src='" + datos.data.data[i].images.low_resolution.url +"'></img></a>");
				   //insert_elements(datos.data.data[i], i++);
				    megustas += '<tr><td class="pfeed_comments_user_td"><a class="pfeed_comments_user"><span>'+likes.data[i].from.username+'</span><img width="24px" src="'+likes.data[i].from.profile_picture+'"/></td>';
				    megustas += '<td><i class="fa fa-comments-o"></i> '+likes.data[i].text+'<td><td class="pfeed_comments_fecha"><small>'+fecha.toLocaleDateString()+'</small></td></tr>';
				}
				megustas += '</table>';
		*/
	} else {
		megustas += '<i class="fa fa-heart"></i>';
	}

	return megustas;
}


function checklicense() {
	if (!pfeed_license) {
		return false;
	} else {
		return true;
	}
}



function pf_debug(msg='') {
	if(pfeed_debug)	console.log(msg);
}