<?php
/**
 * @Copyright
 * @package     Field - license check
 * @author      anton {@link http://www.dibuxo.com}
 * @version     Joomla! 2.5 - 1.0.24
 * @date        Created on 09-09-2013
 * @link        Project Site {@link http://store.dibuxo.com}
 *
 * @license GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

defined('JPATH_PLATFORM') or die;

class JFormFieldPfeedapibutton extends JFormField
{
    protected $type = 'pfeedapibutton';

    protected function getLabel(){
        //return '<strong>'.JText::_('DX_PUBLI').'</strong>';
    }

    protected function getInput()
    {
        $field_set = $this->form->getFieldset();

        /*$field_value='
          <a class="btn btn-info bk_pfeed_getauth" href="https://www.instagram.com/oauth/authorize/?client_id=9476f75ea152464da90dc2e1a74f8ab0&redirect_uri=http://soft.dibuxo.com/API/photofeed/photofeed_auth.php&response_type=token" target="_blank">Get Auth</a>
        ';*/

          //FORCE AUTH
        /*$field_value='
          <a class="btn btn-success bk_pfeed_getauth " href="https://www.instagram.com/oauth/authorize/?force_authentication=1&client_id=1376886462511823&redirect_uri=https://soft.dibuxo.com/API/photofeed/photofeed_auth.php&response_type=code&scope=user_profile,user_media" target="_blank"><i class="fas fa-lock-open"></i> Get Auth</a>
        ';*/
        //V2
        $field_value='
          <a class="btn btn-success bk_pfeed_getauth " href="https://www.instagram.com/oauth/authorize/?client_id=1376886462511823&redirect_uri=https://soft.dibuxo.com/API/photofeed/photofeed_auth.php&response_type=code&scope=user_profile,user_media" target="_blank"><i class="fas fa-lock-open"></i> Get Auth</a>
        ';







        $field_set = $this->form->getFieldset();
        $params = $this->form->getValue('params');
        //$params = null;


        if(isset($params->access_token)){

          if($params->access_token){

            $field_value .='
              <a class="btn btn-info bk_pfeed_renew modal" href="https://soft.dibuxo.com/API/photofeed/photofeed_renew.php?access_token='.$params->access_token.'" target="_blank" rel="{handler:\'iframe\', size: {x: 1024, y: 600}}"><i class="fas fa-recycle"></i> Renew</a>
            '; 

          }
        }





     


        
    
        return $field_value;
    }

}
