<?php
/**
 * @package     mod_pfeed
 *
 * @copyright   Copyright (C) 2005 - 2021 Jtotal. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/
defined('JPATH_PLATFORM') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use JTFramework\Fa5;

if (is_file(JPATH_PLUGINS . '/system/jtframework/autoload.php'))
{
    require_once JPATH_PLUGINS . '/system/jtframework/autoload.php';
}else{
    $app = Factory::getApplication();
    $app->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}


class JFormFieldpfeedbackend extends FormField
{
    protected $type = 'pfeedbackend';

    protected function getLabel(){
        //return "<strong>License</strong>";
    }

    protected function getInput()
    {

        Fa5::getFaCDN();

        $field_set = $this->form->getFieldset();

        //$field_value='<div class="alert alert-success">'.JText::_('SOCIAL2S_FIELD_LICENSE_OK').'</div>';
        $document = Factory::getDocument();
        $plugin_path = Uri::root().'/modules/mod_pfeed';
        //$document->addStyleSheet($plugin_path.'/assets/css/font-awesome.min.css', 'text/css');


        $document->addScript($plugin_path.'/assets/js/pfeed_backend.min.js', 'text/javascript');
        $document->addStyleSheet($plugin_path.'/assets/css/pfeed_backend.css', 'text/css');
        //$field_set = $this->form->getFieldset();
        $field_value = "";

        return $field_value;
    }

}
